@echo off
rem *** Author: T. Wittrock, RZ Uni Kiel ***

setlocal enableextensions
if errorlevel 1 goto NoExtensions

%~d0
cd "%~p0"

for %%i in (w2k w2k3 wxp) do (if /i "%1"=="%%i" goto Valid1)
if /i "%1"=="all" (
  if %2~==~ (set OUTPUT_PATH=..\iso) else (set OUTPUT_PATH=%~fs2)
  goto Valid2
)
goto InValid1
:Valid1
if %3~==~ (set OUTPUT_PATH=..\iso) else (set OUTPUT_PATH=%~fs3)
for %%i in (deu enu) do (if /i "%2"=="%%i" goto Valid2)
goto InValid2
:Valid2

if not exist ..\bin\mkisofs.exe goto NoMkIsoFs

rem *** Create ISO image ***
if /i "%1"=="all" goto All
title Creating ISO image for %1 %2...
echo Creating ISO image for %1 %2...
if exist %OUTPUT_PATH%\wsusoffline-%1-%2.iso del %OUTPUT_PATH%\wsusoffline-%1-%2.iso
..\bin\mkisofs.exe -iso-level 4 -joliet -joliet-long -rational-rock -exclude-list ..\exclude\exclude-list-iso-%1-%2.txt -output %OUTPUT_PATH%\wsusoffline-%1-%2.iso -volid WSUSoffline-%1-%2 ..\client
if errorlevel 1 goto MkIsoError
goto EoF

:All
title Creating ISO image for all platforms...
echo Creating ISO image for all platforms...
if exist %OUTPUT_PATH%\wsusoffline-%1.iso del %OUTPUT_PATH%\wsusoffline-%1.iso
..\bin\mkisofs.exe -iso-level 4 -joliet -joliet-long -rational-rock -exclude-list ..\exclude\exclude-list-iso-%1.txt -output %OUTPUT_PATH%\wsusoffline-%1.iso -volid WSUSoffline-%1 ..\client
if errorlevel 1 goto MkIsoError
goto EoF

:NoExtensions
echo.
echo ERROR: No command extensions available.
echo.
goto Error

:InValid1
echo.
echo ERROR: Invalid parameter %1
echo Usage: %~n0 {w2k ^| w2k3 ^| wxp} {deu ^| enu}
echo.
goto EoF

:InValid2
echo.
echo ERROR: Invalid parameter %2
echo Usage: %~n0 {w2k ^| w2k3 ^| wxp} {deu ^| enu}
echo.
goto EoF

:NoMkIsoFs
echo.
echo ERROR: Utility ..\bin\mkisofs.exe not found.
echo.
goto Error

:MkIsoError
echo.
echo ERROR: Creation of ISO image failed.
echo.
goto Error

:Error
endlocal
pause
SignalError.exe
exit

:EoF
title %ComSpec%
endlocal
